osg::Geode Class Reference

`#include <Geode>`

Inheritance diagram for osg::Geode:

## Public Member Functions

| Geode ()
| Geode (const Geode &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Geode)
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual bool | addDrawable (Drawable *drawable)
template<class T>
bool | addDrawable (const ref_ptr< T > &drawable)
virtual bool | removeDrawable (Drawable *drawable)
template<class T>
bool | removeDrawable (const ref_ptr< T > &drawable)
virtual bool | removeDrawables (unsigned int i, unsigned int numDrawablesToRemove=1)
virtual bool | replaceDrawable (Drawable *origDraw, Drawable *newDraw)
template<class T, class R>
bool | replaceDrawable (const ref_ptr< T > &origDraw, const ref_ptr< R > &newDraw)
virtual bool | setDrawable (unsigned int i, Drawable *drawable)
template<class T>
bool | setDrawable (unsigned int i, const ref_ptr< T > &drawable)
unsigned int | getNumDrawables () const
Drawable * | getDrawable (unsigned int i)
const Drawable * | getDrawable (unsigned int i) const
bool | containsDrawable (const Drawable *drawable) const
template<class T>
bool | containsDrawable (const ref_ptr< T > &drawable) const
unsigned int | getDrawableIndex (const Drawable *drawable) const
template<class T>
unsigned int | getDrawableIndex (const ref_ptr< T > &drawable) const
void | compileDrawables (RenderInfo &renderInfo)
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Geode ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::BoundingBox | _bbox
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A `Geode` is a "geometry node", that is, a leaf node on the scene graph that can have "renderable things" attached to it. In OSG, renderable things are represented by objects from the `Drawable` class, so a `Geode` is a `Node` whose purpose is grouping Drawables.

## Constructor & Destructor Documentation

## Geode() [1/2]

osg::Geode::Geode | ( |  | ) |

Referenced by asGeode(), asGeode(), Geode(), META_Node(), osgSim::ScalarBar::ScalarBar(), osgSim::ScalarBar::ScalarBar(), osgSim::ScalarBar::ScalarBar(), and osgSim::SphereSegment::SphereSegment().

## Geode() [2/2]

osg::Geode::Geode | ( | const Geode & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Geode(), and osg::CopyOp::SHALLOW_COPY.

## ~Geode()

virtual osg::Geode::~Geode | ( |  | ) |

protected virtual

## Member Function Documentation

## addDrawable() [1/2]

template<class T>

bool osg::Geode::addDrawable | ( | const ref_ptr< T > & | drawable | ) |

inline

References addDrawable(), and osg::ref_ptr< T >::get().

Referenced by addDrawable().

## addDrawable() [2/2]

virtual bool osg::Geode::addDrawable | ( | Drawable * | drawable | ) |

virtual

Add a `Drawable` to the `Geode`. If `drawable` is not `NULL` and is not contained in the `Geode` then increment its reference count, add it to the drawables list and dirty the bounding sphere to force it to be recomputed on the next call to `getBound()`.

Parameters

  drawable | The `Drawable` to be added to the `Geode`.

Returns
  `true` for success; `false` otherwise.

Reimplemented in osg::Billboard.

## asGeode() [1/2]

virtual Geode * osg::Geode::asGeode | ( |  | ) |

inline virtual

Convert 'this' into a Geode pointer if Node is a Geode, otherwise return 0. Equivalent to dynamic_cast<Geode*>(this).

Reimplemented from osg::Node.

References Geode().

## asGeode() [2/2]

virtual const Geode * osg::Geode::asGeode | ( |  | ) | const

inline virtual

convert 'const this' into a const Geode pointer if Node is a Geode, otherwise return 0. Equivalent to dynamic_cast<const Geode*>(this).

Reimplemented from osg::Node.

References Geode().

## compileDrawables()

void osg::Geode::compileDrawables | ( | RenderInfo & | renderInfo | ) |

Compile OpenGL Display List for each drawable.

## computeBound()

virtual BoundingSphere osg::Geode::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

Reimplemented in osg::Billboard, and osgSim::SphereSegment.

## containsDrawable() [1/2]

bool osg::Geode::containsDrawable | ( | const Drawable * | drawable | ) | const

inline

Return `true` if a given `Drawable` is contained within `Geode`.

References osg::Group::_children.

## containsDrawable() [2/2]

template<class T>

bool osg::Geode::containsDrawable | ( | const ref_ptr< T > & | drawable | ) | const

inline

References containsDrawable(), and osg::ref_ptr< T >::get().

Referenced by containsDrawable().

## getBoundingBox()

const BoundingBox & osg::Geode::getBoundingBox | ( |  | ) | const

inline

Return the Geode's bounding box, which is the union of all the bounding boxes of the geode's drawables.

References _bbox, osg::Node::_boundingSphereComputed, and osg::Node::getBound().

## getDrawable() [1/2]

Drawable * osg::Geode::getDrawable | ( | unsigned int | i | ) |

inline

Return the `Drawable` at position `i`.

References osg::Group::_children.

## getDrawable() [2/2]

const Drawable * osg::Geode::getDrawable | ( | unsigned int | i | ) | const

inline

Return the `Drawable` at position `i`.

References osg::Group::_children.

## getDrawableIndex() [1/2]

unsigned int osg::Geode::getDrawableIndex | ( | const Drawable * | drawable | ) | const

inline

Get the index number of `drawable`.

Returns
  A value between 0 and getNumDrawables()-1 if `drawable` is found; if not found, then getNumDrawables() is returned.

References osg::Group::getChildIndex().

## getDrawableIndex() [2/2]

template<class T>

unsigned int osg::Geode::getDrawableIndex | ( | const ref_ptr< T > & | drawable | ) | const

inline

References osg::ref_ptr< T >::get(), and getDrawableIndex().

Referenced by getDrawableIndex().

## getNumDrawables()

unsigned int osg::Geode::getNumDrawables | ( |  | ) | const

inline

Return the number of Drawables currently attached to the `Geode`.

References osg::Group::getNumChildren().

## META_Node()

osg::Geode::META_Node | ( | osg | ,
|  | Geode | )

References Geode().

## removeDrawable() [1/2]

template<class T>

bool osg::Geode::removeDrawable | ( | const ref_ptr< T > & | drawable | ) |

inline

References osg::ref_ptr< T >::get(), and removeDrawable().

Referenced by removeDrawable().

## removeDrawable() [2/2]

virtual bool osg::Geode::removeDrawable | ( | Drawable * | drawable | ) |

virtual

Remove a `Drawable` from the `Geode`. Equivalent to removeDrawable(getDrawableIndex(drawable).

Parameters

  drawable | The drawable to be removed.

Returns
  `true` if at least one `Drawable` was removed. `false` otherwise.

Reimplemented in osg::Billboard.

## removeDrawables()

virtual bool osg::Geode::removeDrawables | ( | unsigned int | i,
|  | unsigned int | numDrawablesToRemove = 1 )

virtual

Remove Drawable(s) from the specified position in Geode's drawable list.

Parameters

  i | The index of the first `Drawable` to remove.
  numDrawablesToRemove | The number of Drawable to remove.

Returns
  `true` if at least one `Drawable` was removed. `false` otherwise.

## replaceDrawable() [1/2]

template<class T, class R>

bool osg::Geode::replaceDrawable | ( | const ref_ptr< T > & | origDraw,
|  | const ref_ptr< R > & | newDraw )

inline

References osg::ref_ptr< T >::get(), and replaceDrawable().

Referenced by replaceDrawable().

## replaceDrawable() [2/2]

virtual bool osg::Geode::replaceDrawable | ( | Drawable * | origDraw,
|  | Drawable * | newDraw )

virtual

Replace specified Drawable with another Drawable. Equivalent to setDrawable(getDrawableIndex(origDraw),newDraw), see docs for `setDrawable()` for further details on implementation.

## setDrawable() [1/2]

template<class T>

bool osg::Geode::setDrawable | ( | unsigned int | i,
|  | const ref_ptr< T > & | drawable )

inline

References osg::ref_ptr< T >::get(), and setDrawable().

Referenced by setDrawable().

## setDrawable() [2/2]

virtual bool osg::Geode::setDrawable | ( | unsigned int | i,
|  | Drawable * | drawable )

virtual

Set `Drawable` at position `i`. Decrement the reference count origGSet and increments the reference count of newGset, and dirty the bounding sphere to force it to recompute on next getBound() and returns true. If origDrawable is not found then return false and do not add newGset. If newGset is NULL then return false and do not remove origGset.

Returns
  `true` if set correctly, `false` on failure (if node==NULL || i is out of range).

## Member Data Documentation

## _bbox

osg::BoundingBox osg::Geode::_bbox

mutable protected

Referenced by getBoundingBox().

The documentation for this class was generated from the following file:

- Geode